/*!
 * Backbone.GoogleMaps
 * A Backbone JS layer for the GoogleMaps API
 * Copyright (c)2012 Edan Schwartz
 * Distributed under MIT license
 * https://github.com/eschwartz/backbone.googlemaps
 */
(function(a,b){if(typeof define==="function"&&define.amd){define(["backbone","underscore","jquery"],b)}else{b(a.Backbone,a._,a.jQuery||a.Zepto||a.ender)}}(this,function(d,b,c){var a={};a.Location=d.Model.extend({constructor:function(){b.bindAll(this,"select","deselect","toggleSelect","getLatLng","getLatlng");this.defaults=b.extend({},{lat:0,lng:0,selected:false,title:""},this.defaults);d.Model.prototype.constructor.apply(this,arguments);this.on("change:selected",function(g,f){var e=f?"selected":"deselected";this.trigger(e,this)},this)},select:function(){this.set("selected",true)},deselect:function(){this.set("selected",false)},toggleSelect:function(){this.set("selected",!this.get("selected"))},getLatlng:function(){return this.getLatLng()},getLatLng:function(){return new google.maps.LatLng(this.get("lat"),this.get("lng"))}});a.LocationCollection=d.Collection.extend({model:a.Location,constructor:function(){d.Collection.prototype.constructor.apply(this,arguments);this.on("change:selected",function(e,f){if(f){this.each(function(g){if(e.cid!==g.cid){g.deselect()}})}},this)}});a.MapView=d.View.extend({mapEvents:{},overlayOptions:{},constructor:function(){b.bindAll(this,"render","close");d.View.prototype.constructor.apply(this,arguments);if(!google||!google.maps){throw new Error("Google maps API is not loaded.")}if(!this.options.map&&!this.map){throw new Error("A map must be specified.")}this.gOverlay=this.map=this.options.map||this.map;this.overlayOptions||(this.overlayOptions=this.options.overlayOptions)},bindMapEvents:function(g){g||(g=this.mapEvents);for(var f in g){var e=g[f];google.maps.event.addListener(this.gOverlay,f,this[e])}},render:function(){this.trigger("before:render");if(this.beforeRender){this.beforeRender()}this.bindMapEvents();this.trigger("render");if(this.onRender){this.onRender()}return this},close:function(){this.trigger("before:close");if(this.beforeClose){this.beforeClose()}google.maps.event.clearInstanceListeners(this.gOverlay);if(this.gOverlay.setMap){this.gOverlay.setMap(null)}this.gOverlay=null;this.trigger("close");if(this.onClose){this.onClose()}}});a.InfoWindow=a.MapView.extend({constructor:function(){a.MapView.prototype.constructor.apply(this,arguments);b.bindAll(this,"render","close");if(!this.options.marker&&!this.marker){throw new Error("A marker must be specified for InfoWindow view.")}this.marker=this.options.marker||this.marker;this.template=this.template||this.options.template},render:function(){this.trigger("before:render");if(this.beforeRender){this.beforeRender()}a.MapView.prototype.render.apply(this,arguments);var e=(this.template)?c(this.template).html():"<h2><%=title %></h2>";this.$el.html(b.template(e,this.model.toJSON()));this.gOverlay=new google.maps.InfoWindow(b.extend({content:this.$el[0]},this.overlayOptions));this.gOverlay.open(this.map,this.marker);this.trigger("render");if(this.onRender){this.onRender()}return this},close:function(){this.trigger("before:close");if(this.beforeClose){this.beforeClose()}a.MapView.prototype.close.apply(this,arguments);this.trigger("close");if(this.onClose){this.onClose()}return this}});a.MarkerView=a.MapView.extend({infoWindow:a.InfoWindow,constructor:function(){a.MapView.prototype.constructor.apply(this,arguments);b.bindAll(this,"render","close","openDetail","closeDetail","toggleSelect");if(!this.model){throw new Error("A model must be specified for a MarkerView")}this.gOverlay=new google.maps.Marker(b.extend({position:this.model.getLatLng(),map:this.map,title:this.model.title,animation:google.maps.Animation.DROP,visible:false},this.overlayOptions));b.extend(this.mapEvents,{click:"toggleSelect"});this.model.on("change:selected",function(f,e){if(e){this.openDetail()}else{this.closeDetail()}},this);this.model.on("change:lat change:lng",this.refreshOverlay,this);this.bindMapEvents({position_changed:"updateModelPosition"})},refreshOverlay:function(){if(!this.model.getLatLng().equals(this.gOverlay.getPosition())){this.gOverlay.setOptions({position:this.model.getLatLng()})}},updateModelPosition:function(){var e=this.gOverlay.getPosition();if(!this.model.getLatLng().equals(e)){this.model.set({lat:e.lat(),lng:e.lng()})}},toggleSelect:function(){this.model.toggleSelect()},render:function(){this.trigger("before:render");if(this.beforeRender){this.beforeRender()}a.MapView.prototype.render.apply(this,arguments);this.gOverlay.setVisible(true);this.trigger("render");if(this.onRender){this.onRender()}return this},close:function(){this.trigger("before:close");if(this.beforeClose){this.beforeClose()}this.closeDetail();a.MapView.prototype.close.apply(this,arguments);this.model.off();this.trigger("close");if(this.onClose){this.onClose()}return this},openDetail:function(){this.detailView=new this.infoWindow({model:this.model,map:this.map,marker:this.gOverlay});this.detailView.render()},closeDetail:function(){if(this.detailView){this.detailView.close();this.detailView=null}}});a.MarkerCollectionView=d.View.extend({markerView:a.MarkerView,markerViewChildren:{},constructor:function(){d.View.prototype.constructor.apply(this,arguments);b.bindAll(this,"render","closeChildren","closeChild","addChild","refresh","close");if(!this.options.map&&!this.map){throw new Error("A map must be specified on MarkerCollectionView instantiation")}this.map||(this.map=this.options.map);this.collection.on("reset",this.refresh,this);this.collection.on("add",this.addChild,this);this.collection.on("remove",this.closeChild,this)},render:function(e){var e=e||this.collection;this.trigger("before:render");if(this.beforeRender){this.beforeRender()}e.each(this.addChild);this.trigger("render");if(this.onRender){this.onRender()}return this},closeChildren:function(){for(var e in this.markerViewChildren){this.closeChild(this.markerViewChildren[e])}},closeChild:function(f){var e=(f instanceof d.Model)?this.markerViewChildren[f.cid]:f;e.close();delete this.markerViewChildren[e.model.cid]},addChild:function(f){var e=new this.markerView({model:f,map:this.map});this.markerViewChildren[f.cid]=e;e.render()},refresh:function(){this.closeChildren();this.render()},close:function(){this.closeChildren();this.collection.off()}});d.GoogleMaps=a;return a}));